package com.jkcredit.asynchronous.callback.util;

import lombok.extern.slf4j.Slf4j;
import okhttp3.*;

import java.io.IOException;
import java.util.concurrent.TimeUnit;

/**
 * @author xusonglin
 * @version V1.0
 **/
@Slf4j
public class OkHttpUtil {
    private static OkHttpClient okHttpClient = new OkHttpClient.Builder().build();
    private static final String MEDIA_TYPE = "application/json;charset=UTF-8";

    public static String sendPost(String url, String jsonStr, int outTime) {
        MediaType mediaType = MediaType.parse(MEDIA_TYPE);
        RequestBody requestBody = RequestBody.create(mediaType, jsonStr);
        Request okRequest = new Request.Builder()
                .post(requestBody)
                .url(url)
                .build();
        OkHttpClient client = okHttpClient.newBuilder()
                .connectTimeout(2000, TimeUnit.MILLISECONDS)
                .readTimeout(outTime, TimeUnit.MILLISECONDS)
                .writeTimeout(outTime, TimeUnit.MILLISECONDS)
                .build();
        String responseContext = "";
        try {
            Response response = client.newCall(okRequest).execute();
            if (response.body() != null) {
                responseContext = response.body().string();
            }
        } catch (IOException ioe) {
            log.error("requestParam:{}, requestUrl:{}, Exception:{}", jsonStr, url, ioe);
        }
        return responseContext;
    }
}
